'
' Use an ADC channel to create a random bit, then use this bit to build random bytes or words
' Display Dice faces on the serial terminal
'
    
$define Random_ADC_Channel 1                ' Use AN0 as the random bit generator ADC channel
    Include "Real_Random.inc"               ' Load the Real Random macros into the program

    Dim wRandomResult As Word
    Dim bRandomResult As wRandomResult.Byte0
    Dim Found_Six As Byte
    Dim Found_Five As Byte
    Dim Found_Four As Byte
    Dim Found_Three As Byte
    Dim Found_Two As Byte
    Dim Found_One As Byte

'------------------------------------------------------------------------------------------------
' The main program loop starts here
' Create the faces of a dice on the serial terminal
' and show how many times a number is chosen
'
Main:
    Clear
    While 1 = 1                             ' Create an infinite loop
        HRSOut 1                            ' Clear the serial terminal
TryAgain:
        Random_Get(7, bRandomResult)        ' Create a random value between 0 and 6
        Select bRandomResult                ' Check the value of the random number
            Case 6
                HRSOut "-----------\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "-----------\r"
                Inc Found_Six
            Case 5
                HRSOut "-----------\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "|    O    |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "-----------\r"
                Inc Found_Five
            Case 4
                HRSOut "-----------\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "-----------\r"
                Inc Found_Four
            Case 3
                HRSOut "-----------\r"
                HRSOut "| O       |\r"
                HRSOut "|         |\r"
                HRSOut "|    O    |\r"
                HRSOut "|         |\r"
                HRSOut "|       O |\r"
                HRSOut "-----------\r"
                Inc Found_Three
            Case 2
                HRSOut "-----------\r"
                HRSOut "|       O |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "| O       |\r"
                HRSOut "-----------\r"
                Inc Found_Two
            Case 1
                HRSOut "-----------\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "|    O    |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "-----------\r"
                Inc Found_One
            Case Else
                GoTo TryAgain
        EndSelect
        '
        ' Display how many times a number is chosen
        '
        HRSOut "Amount of times found\r"
        HRSOut "6: (", Dec3 Found_Six, ") ", Rep "*"\Found_Six, 13
        HRSOut "5: (", Dec3 Found_Five, ") ", Rep "*"\Found_Five, 13
        HRSOut "4: (", Dec3 Found_Four, ") ", Rep "*"\Found_Four, 13
        HRSOut "3: (", Dec3 Found_Three, ") ", Rep "*"\Found_Three, 13
        HRSOut "2: (", Dec3 Found_Two, ") ", Rep "*"\Found_Two, 13
        HRSOut "1: (", Dec3 Found_One, ") ", Rep "*"\Found_One, 13

        DelayMS 500                         ' Delay for 500 milliseconds
        Random_Get(500, wRandomResult)      ' Get a random value between 0 and 499
        DelayMS wRandomResult               ' Delay by the random number of milliseconds
    Wend


